///////////////////////////////////////////////////////////////////////////////////////////
//                                                   41 Post                             //
// Android: loading images from a remote location, SD card and from the Resources folder //
// Created by DimasTheDriver in 25/Jan/2011                                      		 //
// Availiable at:       http://www.41post.com/?p=2744                           		 //
///////////////////////////////////////////////////////////////////////////////////////////

package fortyonepost.com.cv;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import android.os.Bundle;
import android.os.Handler;


public class CanvasExample extends Activity implements Runnable
{
	//set the custom view
	private CustomView view;
	//the handler object is used to update the UI thread from another one
	private Handler handler = new Handler();
	//the bitmap to be downloaded
	public Bitmap downloadedBitmap;


    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        
        //instantiate a view object
        view = new CustomView(this);
		
        //starts a new thread that will execute the code from the run() method
		new Thread(this).start();
		
		//set this view as the content of this Activity
        setContentView(view);  
     
    }
    
    //This method is responsible for downloading the image from a remote location
	private Bitmap DownloadBMP(String url) throws IOException
	{
		//create a URL object from the passed string
		URL location = new URL(url);
		//create a InputStream object, to read data from a remote location
		InputStream is = location.openStream();
		//use the BitmapFactory to decode this downloaded stream into a bitmap
		Bitmap returnedBMP = BitmapFactory.decodeStream(is);
		//close the InputStream
		is.close();
		//returns the downloaded bitmap
		return returnedBMP;
	}
	
	//this method must be overridden, as we are implementing the runnable interface
	@Override
	public void run() 
	{
		//update the canvas from this thread
		handler.post(new Runnable() 
		{
			@Override
			public void run() 
			{
				//try to download the image from a remote location
				try 
				{
					downloadedBitmap = DownloadBMP("http://img41.imageshack.us/img41/426/bricks.gif");
				} 
				//if the image couldn't be downloaded, return the standard 'Image not found' bitmap
				catch (IOException e) 
				{
					downloadedBitmap = BitmapFactory.decodeResource(getResources(), R.drawable.imagenotfound);
				}
			}
		});
	}
}